From 9200391d41969a1915fae43dd8904ef3e126fd48 Mon Sep 17 00:00:00 2001
From: Karel Zak <kzak@redhat.com>
Date: Wed, 13 May 2015 15:06:22 +0200
Subject: [PATCH] tests: update lscpu tests (due to CPU flags in output)

Signed-off-by: Karel Zak <kzak@redhat.com>
---
 tests/expected/lscpu/lscpu-s390-kvm          | 1 +
 tests/expected/lscpu/lscpu-s390-lpar         | 1 +
 tests/expected/lscpu/lscpu-s390-zvm          | 1 +
 tests/expected/lscpu/lscpu-sparc64           | 1 +
 tests/expected/lscpu/lscpu-vbox-win          | 1 +
 tests/expected/lscpu/lscpu-x86_64-64cpu      | 1 +
 tests/expected/lscpu/lscpu-x86_64-dell_e4310 | 1 +
 7 files changed, 7 insertions(+)

diff --git a/tests/expected/lscpu/lscpu-s390-kvm b/tests/expected/lscpu/lscpu-s390-kvm
index 1aa42f9..9632b05 100644
--- a/tests/expected/lscpu/lscpu-s390-kvm
+++ b/tests/expected/lscpu/lscpu-s390-kvm
@@ -11,6 +11,7 @@ Hypervisor:            KVM/Linux
 Hypervisor vendor:     KVM
 Virtualization type:   full
 Dispatching mode:      horizontal
+Flags:                 esan3 zarch stfle msa ldisp eimm dfp edat etf3eh highgprs
 
 # The following is the parsable format, which can be fed to other
 # programs. Each different item in every column has an unique ID
diff --git a/tests/expected/lscpu/lscpu-s390-lpar b/tests/expected/lscpu/lscpu-s390-lpar
index 0799ab9..a426566 100644
--- a/tests/expected/lscpu/lscpu-s390-lpar
+++ b/tests/expected/lscpu/lscpu-s390-lpar
@@ -12,6 +12,7 @@ Hypervisor:            PR/SM
 Hypervisor vendor:     IBM
 Virtualization type:   full
 Dispatching mode:      vertical
+Flags:                 esan3 zarch stfle msa ldisp eimm dfp etf3eh highgprs
 
 # The following is the parsable format, which can be fed to other
 # programs. Each different item in every column has an unique ID
diff --git a/tests/expected/lscpu/lscpu-s390-zvm b/tests/expected/lscpu/lscpu-s390-zvm
index 04dcf76..6cf24bf 100644
--- a/tests/expected/lscpu/lscpu-s390-zvm
+++ b/tests/expected/lscpu/lscpu-s390-zvm
@@ -11,6 +11,7 @@ Hypervisor:            z/VM 6.1.0
 Hypervisor vendor:     IBM
 Virtualization type:   full
 Dispatching mode:      horizontal
+Flags:                 esan3 zarch stfle msa ldisp eimm dfp etf3eh highgprs
 
 # The following is the parsable format, which can be fed to other
 # programs. Each different item in every column has an unique ID
diff --git a/tests/expected/lscpu/lscpu-sparc64 b/tests/expected/lscpu/lscpu-sparc64
index 4d05e9b..629b399 100644
--- a/tests/expected/lscpu/lscpu-sparc64
+++ b/tests/expected/lscpu/lscpu-sparc64
@@ -4,6 +4,7 @@ On-line CPU(s) list:   6,7,10,11,14,15
 Thread(s) per core:    1
 Core(s) per socket:    1
 Socket(s):             6
+Flags:                 sun4u
 
 # The following is the parsable format, which can be fed to other
 # programs. Each different item in every column has an unique ID
diff --git a/tests/expected/lscpu/lscpu-vbox-win b/tests/expected/lscpu/lscpu-vbox-win
index 569f078..5204adb 100644
--- a/tests/expected/lscpu/lscpu-vbox-win
+++ b/tests/expected/lscpu/lscpu-vbox-win
@@ -20,6 +20,7 @@ L1d cache:             32K
 L1d cache:             32K
 L2d cache:             6144K
 NUMA node0 CPU(s):     0,1
+Flags:                 fpu vme de pse tsc msr pae mce cx8 apic sep mtrr pge mca cmov pat pse36 clflush mmx fxsr sse sse2 ht syscall nx rdtscp lm constant_tsc rep_good nopl pni ssse3 lahf_lm
 
 # The following is the parsable format, which can be fed to other
 # programs. Each different item in every column has an unique ID
diff --git a/tests/expected/lscpu/lscpu-x86_64-64cpu b/tests/expected/lscpu/lscpu-x86_64-64cpu
index 471fdd3..17350e3 100644
--- a/tests/expected/lscpu/lscpu-x86_64-64cpu
+++ b/tests/expected/lscpu/lscpu-x86_64-64cpu
@@ -22,6 +22,7 @@ L3 cache:              18432K
 NUMA node0 CPU(s):     0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40,42,44,46,48,50,52,54,56,58,60,62
 NUMA node2 CPU(s):     1,5,9,13,17,21,25,29,33,37,41,45,49,53,57,61
 NUMA node3 CPU(s):     3,7,11,15,19,23,27,31,35,39,43,47,51,55,59,63
+Flags:                 fpu vme de pse tsc msr pae mce cx8 apic mtrr pge mca cmov pat pse36 clflush dts acpi mmx fxsr sse sse2 ss ht tm pbe syscall nx rdtscp lm constant_tsc arch_perfmon pebs bts rep_good xtopology nonstop_tsc aperfmperf pni dtes64 monitor ds_cpl vmx est tm2 ssse3 cx16 xtpr pdcm dca sse4_1 sse4_2 x2apic popcnt lahf_lm ida epb dts tpr_shadow vnmi flexpriority ept vpid
 
 # The following is the parsable format, which can be fed to other
 # programs. Each different item in every column has an unique ID
diff --git a/tests/expected/lscpu/lscpu-x86_64-dell_e4310 b/tests/expected/lscpu/lscpu-x86_64-dell_e4310
index 900199d..929cdf9 100644
--- a/tests/expected/lscpu/lscpu-x86_64-dell_e4310
+++ b/tests/expected/lscpu/lscpu-x86_64-dell_e4310
@@ -20,6 +20,7 @@ L1i cache:             32K
 L2 cache:              256K
 L3 cache:              3072K
 NUMA node0 CPU(s):     0-3
+Flags:                 fpu vme de pse tsc msr pae mce cx8 apic sep mtrr pge mca cmov pat pse36 clflush dts acpi mmx fxsr sse sse2 ss ht tm pbe syscall nx rdtscp lm constant_tsc arch_perfmon pebs bts rep_good nopl xtopology nonstop_tsc aperfmperf pni pclmulqdq dtes64 monitor ds_cpl vmx smx est tm2 ssse3 cx16 xtpr pdcm sse4_1 sse4_2 popcnt aes lahf_lm ida arat dts tpr_shadow vnmi flexpriority ept vpid
 
 # The following is the parsable format, which can be fed to other
 # programs. Each different item in every column has an unique ID
-- 
2.8.1